服务端 API/消息/消息管理/转发消息
# 转发消息

向用户、群聊或话题转发一条指定消息。

**注意事项**：注意事项:
- 需要开启[机器人能力](https://open.larksuite.com/document/uAjLw4CM/ugTN1YjL4UTN24CO1UjN/trouble-shooting/how-to-enable-bot-ability)  
- 向用户转发消息，需要机器人对用户有[可用性](https://open.larksuite.com/document/home/introduction-to-scope-and-authorization/availability)
- 向群组转发消息，需要机器人在群组中
- 对于要转发的消息与转发到的对象，本接口有以下限制：
     - 不支持红包、投票、语音、日程转让等消息类型
    - 不支持再次转发合并转发消息中的子消息（含有==upper_message_id==字段的消息）
-  为避免对用户造成打扰，向同一用户发送消息的限频为 ==5 QPS==，向同一群组发送消息的限频为群内机器人共享 ==5 QPS==

## 请求

基本 | &nbsp;
---|---
HTTP URL | https://open.larksuite.com/open-apis/im/v1/messages/:message_id/forward
HTTP Method | POST
接口频率限制 | [1000 次/分钟、50 次/秒](https://open.larksuite.com/document/ukTMukTMukTM/uUzN04SN3QjL1cDN)
支持的应用类型 | Custom App、Store App
权限要求<br>**调用该 API 所需的权限。开启其中任意一项权限即可调用**<br>开启任一权限即可 | 获取与发送单聊、群组消息(im:message)<br>以应用的身份发消息(im:message:send_as_bot)

### 请求头

名称 | 类型 | 必填 | 描述
---|---|---|---
Authorization | string | 是 | `tenant_access_token`<br>**值格式**："Bearer `access_token`"<br>**示例值**："Bearer t-7f1bcd13fc57d46bac21793a18e560"<br>[了解更多：如何选择与获取 access token](https://open.larksuite.com/document/uAjLw4CM/ugTN1YjL4UTN24CO1UjN/trouble-shooting/how-to-choose-which-type-of-token-to-use)
Content-Type | string | 是 | **固定值**："application/json; charset=utf-8"

### 路径参数

名称 | 类型 | 描述
---|---|---
message_id | string | 要转发的消息ID，详情参见[消息ID说明](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/message/intro#ac79c1c2)<br>**示例值**："om_dc13264520392913993dd051dba21dcf"

### 查询参数

名称 | 类型 | 必填 | 描述
---|---|---|---
receive_id_type | string | 是 | 消息接收者id类型 open_id/user_id/union_id/email/chat_id/thread_id<br>**示例值**：open_id<br>**可选值有**：<br>- open_id：标识一个用户在某个应用中的身份。同一个用户在不同应用中的 Open ID 不同。[了解更多：如何获取 Open ID](https://open.larksuite.com/document/uAjLw4CM/ugTN1YjL4UTN24CO1UjN/trouble-shooting/how-to-obtain-openid)<br>- user_id：标识一个用户在某个租户内的身份。同一个用户在租户 A 和租户 B 内的 User ID 是不同的。在同一个租户内，一个用户的 User ID 在所有应用（包括商店应用）中都保持一致。User ID 主要用于在不同的应用间打通用户数据。[了解更多：如何获取 User ID？](https://open.larksuite.com/document/uAjLw4CM/ugTN1YjL4UTN24CO1UjN/trouble-shooting/how-to-obtain-user-id)<br>- union_id：标识一个用户在某个应用开发商下的身份。同一用户在同一开发商下的应用中的 Union ID 是相同的，在不同开发商下的应用中的 Union ID 是不同的。通过 Union ID，应用开发商可以把同个用户在多个应用中的身份关联起来。[了解更多：如何获取 Union ID？](https://open.larksuite.com/document/uAjLw4CM/ugTN1YjL4UTN24CO1UjN/trouble-shooting/how-to-obtain-union-id)<br>- email：以用户的真实邮箱来标识用户。<br>- chat_id：以群ID来标识群聊。[了解更多：如何获取群ID ](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/chat-id-description)<br>- thread_id：以话题ID来标识话题。了解更多：[话题介绍](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/message/thread-introduction)<br>**当值为 `user_id`，字段权限要求**：<br>获取用户 user ID(contact:user.employee_id:readonly)
uuid | string | 否 | 由开发者生成的唯一字符串序列，用于转发消息请求去重；持有相同uuid的请求在1小时内向同一个目标的转发只可成功一次。<br>**示例值**：b13g2t38-1jd2-458b-8djf-dtbca5104204<br>**数据校验规则**：<br>- 最大长度：`50` 字符

### 请求体

名称 | 类型 | 必填 | 描述
---|---|---|---
receive_id | string | 是 | 依据`receive_id_type`的值，填写对应的转发目标的ID<br>**示例值**："ou_a0553eda9014c201e6969b478895c230"

### 请求体示例
```json
{
    "receive_id": "ou_a0553eda9014c201e6969b478895c230"
}
```

**cURL请求示例**

```json 
curl --location --request POST 'https://open.larksuite.com/open-apis/im/v1/messages/om_dc13264520392913993dd051dba21dcf/forward?receive_id_type=open_id' \
--header 'Authorization: Bearer Bearer t-XXX' \
--header 'Content-Type: application/json; charset=utf-8' \
--data-raw '{
    "receive_id": "ou_a0553eda9014c201e6969b478895c230"
}'
```

## 响应

### 响应体

名称 | 类型 | 描述
---|---|---
code | int | 错误码，非 0 表示失败
msg | string | 错误描述
data | message | \-
message_id | string | 消息id，说明参见：[消息ID说明](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/message/intro#ac79c1c2)
root_id | string | 根消息id，用于回复消息场景，说明参见：[消息ID说明](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/message/intro#ac79c1c2)
parent_id | string | 父消息的id，用于回复消息场景，说明参见：[消息ID说明](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/message/intro#ac79c1c2)
thread_id | string | 消息所属的话题 ID（不返回说明该消息非话题消息），说明参见：[话题介绍](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/message/thread-introduction)
msg_type | string | 消息类型 包括：text、post、image、file、audio、media、sticker、interactive、share_chat、share_user等，类型定义请参考[接收消息Content](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/im-v1/message/events/message_content)
create_time | string | 消息生成的时间戳（毫秒）
update_time | string | 消息更新的时间戳（毫秒）
deleted | boolean | 消息是否被撤回
updated | boolean | 消息是否被更新
chat_id | string | 所属的群
sender | sender | 发送者，可以是用户或应用
id | string | 该字段标识发送者的id
id_type | string | 该字段标识发送者的id类型<br>**可选值有：**<br>- `open_id`<br>- `app_id`
sender_type | string | 该字段标识发送者的类型<br>**可选值有：**<br>- `user`: 用户<br>- `app`: 应用<br>- `anonymous`: 匿名<br>- `unknown`: 未知
tenant_key | string | 为租户在Lark上的唯一标识，用来换取对应的tenant_access_token，也可以用作租户在应用里面的唯一标识
body | message_body | 消息内容
content | string | 消息内容，json结构序列化后的字符串。不同msg_type对应不同内容。消息类型 包括：text、post、image、file、audio、media、sticker、interactive、share_chat、share_user等，类型定义请参考：[接收消息内容](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/im-v1/message/events/message_content)
mentions | mention\[\] | 被@的用户或机器人的id列表
key | string | 被@的用户或机器人的序号。例如，第3个被@到的成员，值为“@_user_3”
id | string | 被@的用户或者机器人的open_id
id_type | string | 被@的用户或机器人 id 类型，目前仅支持 `open_id` ([什么是 Open ID？](https://open.larksuite.com/document/home/user-identity-introduction/open-id))
name | string | 被@的用户或机器人的姓名
tenant_key | string | 为租户在Lark上的唯一标识，用来换取对应的tenant_access_token，也可以用作租户在应用里面的唯一标识
upper_message_id | string | 合并转发消息中，上一层级的消息id message_id，说明参见：[消息ID说明](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/message/intro#ac79c1c2)

### 响应体示例
```json
{
    "code": 0,
    "msg": "success",
    "data": {
        "message_id": "om_dc13264520392913993dd051dba21dcf",
        "root_id": "om_40eb06e7b84dc71c03e009ad3c754195",
        "parent_id": "om_d4be107c616aed9c1da8ed8068570a9f",
        "msg_type": "text",
        "create_time": "1615380573411",
        "update_time": "1615380573411",
        "deleted": false,
        "updated": false,
        "chat_id": "oc_5ad11d72b830411d72b836c20",
        "sender": {
            "id": "cli_9f427eec54ae901b",
            "id_type": "app_id",
            "sender_type": "app",
            "tenant_key": "736588c9260f175e"
        },
        "body": {
            "content": "{\"text\":\"test content\"}"
        }
    }
}
```

### 错误码

HTTP状态码 | 错误码 | 描述 | 排查建议
---|---|---|---
400 | 230001 | Your request contains an invalid request parameter. | 参数错误，请根据接口返回的错误信息并参考文档检查输入参数。
400 | 230002 | The bot can not be outside the group. | 机器人不在对应群组中。
400 | 230006 | Bot ability is not activated. | [机器人能力](https://open.larksuite.com/document/uAjLw4CM/ugTN1YjL4UTN24CO1UjN/trouble-shooting/how-to-enable-bot-ability)未启用 。可在[开发者后台](https://open.larksuite.com/app) -> 应用能力 -> 添加应用能力页面添加机器人功能，发布新版本后生效。
400 | 230013 | Bot has NO availability to this user. | 机器人对用户没有[可用性](https://open.larksuite.com/document/home/introduction-to-scope-and-authorization/availability)。可在[开发者后台](https://open.larksuite.com/app) -> 应用发布 -> 版本管理与发布 -> 创建版本页面编辑应用的可用范围，发布新版本后生效。
400 | 230018 | These operations are NOT allowed at current group settings. | 当前操作被群设置禁止，请检查群设置或联系群管理员。
400 | 230019 | The thread does NOT exist. | 要转发到的话题不存在，请检查 thread_id 是否正确。
400 | 230020 | This operation triggers the frequency limit. | 当前操作触发限频，请降低请求频率。
400 | 230027 | Lack of necessary permissions. | 暂不支持在外部群中进行本操作。
400 | 230029 | User has resigned. | 用户已离职。
400 | 230034 | The receive_id is invalid. | 请求参数中的receive_id不合法，请检查。
400 | 230035 | Send Message Permission deny. | 没有发送消息的权限，请排查群是否已开启禁言，或受到租户维度沟通权限的管控。
400 | 230036 | Tenant crypt key has been deleted. | 租户加密密钥已被删除，请联系企业管理员。
400 | 230038 | Cross tenant p2p chat operate forbid. | 跨租户的单聊不允许通过本接口发送消息。
400 | 230049 | The message is being sent. | 消息正在发送中，请稍后。
400 | 230050 | The message is invisible to the operator. | 该消息对于操作者不可见，无法进行本操作。
400 | 230053 | The user has stopped the bot from sending messages. | 用户已设置不再接收机器人消息，无法主动给用户发送单聊消息。
400 | 230061 | The message type does not support forwarding. | 系统消息、红包、投票、语音、日程转让等消息类型不支持转发。
400 | 230062 | No permission to forward to third-party encryption group. | 没有权限转发到第三方加密群。
400 | 230063 | The chat_id of group to forward is invalid. | 要转发到的群是无效的，请检查chat_id对应的群组是否存在。
400 | 230064 | The message to be forwarded is invalid. | 要转发的消息都是无效的，如不存在、已被撤回、对操作者不可见等。
400 | 230065 | The message to be forwarded has been recalled. | 要转发的消息都已被撤回。
400 | 230066 | The message to be forwarded is in a secret group, forwarding is not supported. | 不支持转发密聊群中的消息。
400 | 230070 | Forwarding of messages in restricted mode is not allowed. | 不支持转发保密消息，请检查消息是否已被设置为保密或群组开启了防泄密模式。
400 | 230074 | The target thread is invisible to the operator. | 要转发到的话题对于操作者不可见。 若群聊关闭了“新成员可查看历史消息”且此话题为操作者进入群聊前创建的，则该话题需要操作者被动订阅才可见，如其他用户在话题中@操作者。
400 | 230110 | Action unavailable as the message has been deleted. | 消息已被删除.
400 | 232009 | Your request specifies a chat which has already been dissolved. | 群组已被解散。

